#include <unistd.h>
#include <stdio.h>
#include <errno.h>

/**
 * ----------------------------------------------
 * ReadSymLink.c - (C) 1999-2000 Erich Roncarolo
 * Package: BYLD 1.0 
 * License: GPL2 (see LICENSE)
 * ----------------------------------------------
 * 
 * This little program print a symbolic link
 * contents (what it links to), and exit
 * successfully.   Exit  with  a  failure
 * if an error occours.
 *
 * Usage: ReadSymLink <file>
 * Returns 0 on success, 'errno' otherwise.
 *
 * To compile (done automagically by BuildRoot): 
 * # gcc -o ReadSymLink ReadSymLink.c
 *
 */

int main(int argc, char *argv[]) {
	char buf[255];
	int i = -1;
	
	if (argc != 2)
		return (-1);
	
	memset(buf,0,255);
	
	i = readlink(argv[1], buf, 255);
	
	if (i >= 0)
		buf[i] = (char)0;
	else
		return (errno);
	
	printf("%s\n",buf);
	return 0;
}
